ENTRY(_stext)
PHDRS {
 text PT_LOAD FLAGS(7);
 note PT_NOTE FLAGS(0);
}
OUTPUT_ARCH(powerpc:common64)
jiffies = jiffies_64;
SECTIONS
{
 . = 0xc000000000000000;
 _text = .;
 _stext = .;
 .head.text : AT(ADDR(.head.text) - (0xc000000000000000 -0x00000000)) {
  KEEP(*(.head.text.first_256B));
  KEEP(*(.head.text.real_vectors));
  *(.head.text.real_trampolines);
  KEEP(*(.head.text.virt_vectors));
  *(.head.text.virt_trampolines);
  KEEP(*(.head.data.fwnmi_page));
 } :text
 __head_end = .;
 .text ALIGN(0) : AT(ADDR(.text) - (0xc000000000000000 -0x00000000)) {
  *(.text.hot .text.hot.* .text .text.fixup .text.unlikely .text.unlikely.* .fixup __ftr_alt_* .ref.text);
  *(.tramp.ftrace.text);
  . = ALIGN(8); __noinstr_text_start = .; *(.noinstr.text) __noinstr_text_end = .;
  . = ALIGN(8); __sched_text_start = .; *(.sched.text) __sched_text_end = .;
  . = ALIGN(8); __cpuidle_text_start = .; *(.cpuidle.text) __cpuidle_text_end = .;
  . = ALIGN(8); __lock_text_start = .; *(.spinlock.text) __lock_text_end = .;
  . = ALIGN(8); __kprobes_text_start = .; *(.kprobes.text) __kprobes_text_end = .;
  . = ALIGN(8); __irqentry_text_start = .; *(.irqentry.text) __irqentry_text_end = .;
  . = ALIGN(8); __softirqentry_text_start = .; *(.softirqentry.text) __softirqentry_text_end = .;
  *(.sfpr);
  *(.meminit.text)
  *(.memexit.text)
 } :text
 . = ALIGN((1 << 16));
 _etext = .;
 PROVIDE(__unused__etext = .);
 . = ALIGN(((1 << 16))); .rodata : AT(ADDR(.rodata) - (0xc000000000000000 -0x00000000)) { __start_rodata = .; *(.rodata) *(.rodata.*) . = ALIGN(32); __sched_class_highest = .; *(__stop_sched_class) *(__dl_sched_class) *(__rt_sched_class) *(__fair_sched_class) *(__idle_sched_class) __sched_class_lowest = .; . = ALIGN(8); __start_ro_after_init = .; *(.data..ro_after_init) . = ALIGN(8); __start___jump_table = .; KEEP(*(__jump_table)) __stop___jump_table = .; __end_ro_after_init = .; . = ALIGN(8); __start___tracepoints_ptrs = .; KEEP(*(__tracepoints_ptrs)) __stop___tracepoints_ptrs = .; *(__tracepoints_strings) } .rodata1 : AT(ADDR(.rodata1) - (0xc000000000000000 -0x00000000)) { *(.rodata1) } .pci_fixup : AT(ADDR(.pci_fixup) - (0xc000000000000000 -0x00000000)) { __start_pci_fixups_early = .; KEEP(*(.pci_fixup_early)) __end_pci_fixups_early = .; __start_pci_fixups_header = .; KEEP(*(.pci_fixup_header)) __end_pci_fixups_header = .; __start_pci_fixups_final = .; KEEP(*(.pci_fixup_final)) __end_pci_fixups_final = .; __start_pci_fixups_enable = .; KEEP(*(.pci_fixup_enable)) __end_pci_fixups_enable = .; __start_pci_fixups_resume = .; KEEP(*(.pci_fixup_resume)) __end_pci_fixups_resume = .; __start_pci_fixups_resume_early = .; KEEP(*(.pci_fixup_resume_early)) __end_pci_fixups_resume_early = .; __start_pci_fixups_suspend = .; KEEP(*(.pci_fixup_suspend)) __end_pci_fixups_suspend = .; __start_pci_fixups_suspend_late = .; KEEP(*(.pci_fixup_suspend_late)) __end_pci_fixups_suspend_late = .; } .builtin_fw : AT(ADDR(.builtin_fw) - (0xc000000000000000 -0x00000000)) ALIGN(8) { __start_builtin_fw = .; KEEP(*(.builtin_fw)) __end_builtin_fw = .; } .printk_index : AT(ADDR(.printk_index) - (0xc000000000000000 -0x00000000)) { __start_printk_index = .; *(.printk_index) __stop_printk_index = .; } __ksymtab : AT(ADDR(__ksymtab) - (0xc000000000000000 -0x00000000)) { __start___ksymtab = .; KEEP(*(SORT(___ksymtab+*))) __stop___ksymtab = .; } __ksymtab_gpl : AT(ADDR(__ksymtab_gpl) - (0xc000000000000000 -0x00000000)) { __start___ksymtab_gpl = .; KEEP(*(SORT(___ksymtab_gpl+*))) __stop___ksymtab_gpl = .; } __kcrctab : AT(ADDR(__kcrctab) - (0xc000000000000000 -0x00000000)) { __start___kcrctab = .; KEEP(*(SORT(___kcrctab+*))) __stop___kcrctab = .; } __kcrctab_gpl : AT(ADDR(__kcrctab_gpl) - (0xc000000000000000 -0x00000000)) { __start___kcrctab_gpl = .; KEEP(*(SORT(___kcrctab_gpl+*))) __stop___kcrctab_gpl = .; } __ksymtab_strings : AT(ADDR(__ksymtab_strings) - (0xc000000000000000 -0x00000000)) { *(__ksymtab_strings) } __init_rodata : AT(ADDR(__init_rodata) - (0xc000000000000000 -0x00000000)) { *(.ref.rodata) *(.meminit.rodata) *(.memexit.rodata) } __param : AT(ADDR(__param) - (0xc000000000000000 -0x00000000)) { __start___param = .; KEEP(*(__param)) __stop___param = .; } __modver : AT(ADDR(__modver) - (0xc000000000000000 -0x00000000)) { __start___modver = .; KEEP(*(__modver)) __stop___modver = .; } . = ALIGN(0); __ex_table : AT(ADDR(__ex_table) - (0xc000000000000000 -0x00000000)) { __start___ex_table = .; KEEP(*(__ex_table)) __stop___ex_table = .; } /DISCARD/ : { *(.note.GNU-stack) } .notes : AT(ADDR(.notes) - (0xc000000000000000 -0x00000000)) { __start_notes = .; KEEP(*(.note.*)) __stop_notes = .; } :text :note __restore_ph : { *(.__restore_ph) } :text . = ALIGN(((1 << 16))); __end_rodata = .;
 .data.rel.ro : AT(ADDR(.data.rel.ro) - (0xc000000000000000 -0x00000000)) {
  *(.data.rel.ro .data.rel.ro.*)
 }
 .branch_lt : AT(ADDR(.branch_lt) - (0xc000000000000000 -0x00000000)) {
  *(.branch_lt)
 }
 .toc1 : AT(ADDR(.toc1) - (0xc000000000000000 -0x00000000)) {
  *(.toc1)
 }
 .got : AT(ADDR(.got) - (0xc000000000000000 -0x00000000)) ALIGN(256) {
  *(.got .toc)
 }
 . = ALIGN(8); __soft_mask_table : AT(ADDR(__soft_mask_table) - (0xc000000000000000 -0x00000000)) { __start___soft_mask_table = .; KEEP(*(__soft_mask_table)) __stop___soft_mask_table = .; }
 . = ALIGN(8); __restart_table : AT(ADDR(__restart_table) - (0xc000000000000000 -0x00000000)) { __start___restart_table = .; KEEP(*(__restart_table)) __stop___restart_table = .; }
 . = ALIGN(8);
 __stf_entry_barrier_fixup : AT(ADDR(__stf_entry_barrier_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___stf_entry_barrier_fixup = .;
  *(__stf_entry_barrier_fixup)
  __stop___stf_entry_barrier_fixup = .;
 }
 . = ALIGN(8);
 __uaccess_flush_fixup : AT(ADDR(__uaccess_flush_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___uaccess_flush_fixup = .;
  *(__uaccess_flush_fixup)
  __stop___uaccess_flush_fixup = .;
 }
 . = ALIGN(8);
 __entry_flush_fixup : AT(ADDR(__entry_flush_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___entry_flush_fixup = .;
  *(__entry_flush_fixup)
  __stop___entry_flush_fixup = .;
 }
 . = ALIGN(8);
 __scv_entry_flush_fixup : AT(ADDR(__scv_entry_flush_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___scv_entry_flush_fixup = .;
  *(__scv_entry_flush_fixup)
  __stop___scv_entry_flush_fixup = .;
 }
 . = ALIGN(8);
 __stf_exit_barrier_fixup : AT(ADDR(__stf_exit_barrier_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___stf_exit_barrier_fixup = .;
  *(__stf_exit_barrier_fixup)
  __stop___stf_exit_barrier_fixup = .;
 }
 . = ALIGN(8);
 __rfi_flush_fixup : AT(ADDR(__rfi_flush_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___rfi_flush_fixup = .;
  *(__rfi_flush_fixup)
  __stop___rfi_flush_fixup = .;
 }
 . = ALIGN(8);
 __spec_barrier_fixup : AT(ADDR(__spec_barrier_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___barrier_nospec_fixup = .;
  *(__barrier_nospec_fixup)
  __stop___barrier_nospec_fixup = .;
 }
 . = ALIGN((1 << 16));
 __srwx_boundary = .;
 __end_rodata = .;
 __init_begin = .;
 .init.text : AT(ADDR(.init.text) - (0xc000000000000000 -0x00000000)) {
  _sinittext = .;
  *(.init.text .init.text.*) *(.text.startup)
  . = ALIGN((1 << 16));
  _einittext = .;
  *(.tramp.ftrace.init);
 } :text
 .exit.text : AT(ADDR(.exit.text) - (0xc000000000000000 -0x00000000)) {
  *(.exit.text) *(.text.exit)
 }
 . = ALIGN((1 << 16));
 .init.data : AT(ADDR(.init.data) - (0xc000000000000000 -0x00000000)) { KEEP(*(SORT(___kentry+*))) *(.init.data init.data.*) *(.init.rodata .init.rodata.*) . = ALIGN(8); __start_kprobe_blacklist = .; KEEP(*(_kprobe_blacklist)) __stop_kprobe_blacklist = .; . = ALIGN(32); __start_error_injection_whitelist = .; KEEP(*(_error_injection_whitelist)) __stop_error_injection_whitelist = .; . = ALIGN(8); __clk_of_table = .; KEEP(*(__clk_of_table)) KEEP(*(__clk_of_table_end)) . = ALIGN(8); __reservedmem_of_table = .; KEEP(*(__reservedmem_of_table)) KEEP(*(__reservedmem_of_table_end)) . = ALIGN(8); __timer_of_table = .; KEEP(*(__timer_of_table)) KEEP(*(__timer_of_table_end)) . = ALIGN(8); __cpu_method_of_table = .; KEEP(*(__cpu_method_of_table)) KEEP(*(__cpu_method_of_table_end)) . = ALIGN(8); __cpuidle_method_of_table = .; KEEP(*(__cpuidle_method_of_table)) KEEP(*(__cpuidle_method_of_table_end)) . = ALIGN(32); __dtb_start = .; KEEP(*(.dtb.init.rodata)) __dtb_end = .; . = ALIGN(8); __irqchip_of_table = .; KEEP(*(__irqchip_of_table)) KEEP(*(__irqchip_of_table_end)) . = ALIGN(8); __governor_thermal_table = .; KEEP(*(__governor_thermal_table)) __governor_thermal_table_end = .; . = ALIGN(8); __earlycon_table = .; KEEP(*(__earlycon_table)) __earlycon_table_end = .; . = ALIGN(8); __start_lsm_info = .; KEEP(*(.lsm_info.init)) __end_lsm_info = .; . = ALIGN(8); __start_early_lsm_info = .; KEEP(*(.early_lsm_info.init)) __end_early_lsm_info = .; . = ALIGN(8); __kunit_suites_start = .; KEEP(*(.kunit_test_suites)) __kunit_suites_end = .; . = ALIGN(16); __setup_start = .; KEEP(*(.init.setup)) __setup_end = .; __initcall_start = .; KEEP(*(.initcallearly.init)) __initcall0_start = .; KEEP(*(.initcall0.init)) KEEP(*(.initcall0s.init)) __initcall1_start = .; KEEP(*(.initcall1.init)) KEEP(*(.initcall1s.init)) __initcall2_start = .; KEEP(*(.initcall2.init)) KEEP(*(.initcall2s.init)) __initcall3_start = .; KEEP(*(.initcall3.init)) KEEP(*(.initcall3s.init)) __initcall4_start = .; KEEP(*(.initcall4.init)) KEEP(*(.initcall4s.init)) __initcall5_start = .; KEEP(*(.initcall5.init)) KEEP(*(.initcall5s.init)) __initcallrootfs_start = .; KEEP(*(.initcallrootfs.init)) KEEP(*(.initcallrootfss.init)) __initcall6_start = .; KEEP(*(.initcall6.init)) KEEP(*(.initcall6s.init)) __initcall7_start = .; KEEP(*(.initcall7.init)) KEEP(*(.initcall7s.init)) __initcall_end = .; __con_initcall_start = .; KEEP(*(.con_initcall.init)) __con_initcall_end = .; . = ALIGN(4); __initramfs_start = .; KEEP(*(.init.ramfs)) . = ALIGN(8); KEEP(*(.init.ramfs.info)) }
 . = ALIGN(8);
 __ftr_fixup : AT(ADDR(__ftr_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___ftr_fixup = .;
  KEEP(*(__ftr_fixup))
  __stop___ftr_fixup = .;
 }
 . = ALIGN(8);
 __mmu_ftr_fixup : AT(ADDR(__mmu_ftr_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___mmu_ftr_fixup = .;
  KEEP(*(__mmu_ftr_fixup))
  __stop___mmu_ftr_fixup = .;
 }
 . = ALIGN(8);
 __lwsync_fixup : AT(ADDR(__lwsync_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___lwsync_fixup = .;
  KEEP(*(__lwsync_fixup))
  __stop___lwsync_fixup = .;
 }
 . = ALIGN(8);
 __fw_ftr_fixup : AT(ADDR(__fw_ftr_fixup) - (0xc000000000000000 -0x00000000)) {
  __start___fw_ftr_fixup = .;
  KEEP(*(__fw_ftr_fixup))
  __stop___fw_ftr_fixup = .;
 }
 . = ALIGN((1 << 16)); .data..percpu : AT(ADDR(.data..percpu) - (0xc000000000000000 -0x00000000)) { __per_cpu_load = .; __per_cpu_start = .; *(.data..percpu..first) . = ALIGN((1 << 16)); *(.data..percpu..page_aligned) . = ALIGN((1 << 7)); *(.data..percpu..read_mostly) . = ALIGN((1 << 7)); *(.data..percpu) *(.data..percpu..shared_aligned) __per_cpu_end = .; }
 . = ALIGN(8);
 .machine.desc : AT(ADDR(.machine.desc) - (0xc000000000000000 -0x00000000)) {
  __machine_desc_start = . ;
  KEEP(*(.machine.desc))
  __machine_desc_end = . ;
 }
 . = ALIGN(8);
 .dynsym : AT(ADDR(.dynsym) - (0xc000000000000000 -0x00000000))
 {
  __dynamic_symtab = .;
  *(.dynsym)
 }
 .dynstr : AT(ADDR(.dynstr) - (0xc000000000000000 -0x00000000)) { *(.dynstr) }
 .dynamic : AT(ADDR(.dynamic) - (0xc000000000000000 -0x00000000))
 {
  __dynamic_start = .;
  *(.dynamic)
 }
 .hash : AT(ADDR(.hash) - (0xc000000000000000 -0x00000000)) { *(.hash) }
 .gnu.hash : AT(ADDR(.gnu.hash) - (0xc000000000000000 -0x00000000)) { *(.gnu.hash) }
 .interp : AT(ADDR(.interp) - (0xc000000000000000 -0x00000000)) { *(.interp) }
 .rela.dyn : AT(ADDR(.rela.dyn) - (0xc000000000000000 -0x00000000))
 {
  __rela_dyn_start = .;
  *(.rela*)
 }
 .exit.data : AT(ADDR(.exit.data) - (0xc000000000000000 -0x00000000)) {
  *(.exit.data .exit.data.*) *(.fini_array .fini_array.*) *(.dtors .dtors.*)
 }
 . = ALIGN((1 << 16));
 __init_end = .;
 . = ALIGN((1 << 16));
 _sdata = .;
 .data : AT(ADDR(.data) - (0xc000000000000000 -0x00000000)) {
  *(.xiptext) *(.data) *(.data..decrypted) *(.ref.data) *(.data..shared_aligned) *(.meminit.data*) *(.memexit.data*) *(.data.unlikely) __start_once = .; *(.data.once) __end_once = .; . = ALIGN(32); *(__tracepoints) . = ALIGN(8); __start___dyndbg_classes = .; KEEP(*(__dyndbg_classes)) __stop___dyndbg_classes = .; __start___dyndbg = .; KEEP(*(__dyndbg)) __stop___dyndbg = .;
  *(.data.rel*)
 }
 . = ALIGN((1 << 14)); .data..init_task : AT(ADDR(.data..init_task) - (0xc000000000000000 -0x00000000)) { . = ALIGN((1 << 14)); __start_init_task = .; init_thread_union = .; init_stack = .; KEEP(*(.data..init_task)) KEEP(*(.data..init_thread_info)) . = __start_init_task + (1 << 14); __end_init_task = .; }
 .data..page_aligned : AT(ADDR(.data..page_aligned) - (0xc000000000000000 -0x00000000)) {
  . = ALIGN((1 << 16)); *(.data..page_aligned) . = ALIGN((1 << 16));
 }
 .data..cacheline_aligned : AT(ADDR(.data..cacheline_aligned) - (0xc000000000000000 -0x00000000)) {
  . = ALIGN((1 << 7)); *(.data..cacheline_aligned)
 }
 .data..read_mostly : AT(ADDR(.data..read_mostly) - (0xc000000000000000 -0x00000000)) {
  . = ALIGN((1 << 7)); *(.data..read_mostly) . = ALIGN((1 << 7));
 }
 . = ALIGN((1 << 16));
 .data_nosave : AT(ADDR(.data_nosave) - (0xc000000000000000 -0x00000000)) {
  . = ALIGN((1 << 16)); __nosave_begin = .; *(.data..nosave) . = ALIGN((1 << 16)); __nosave_end = .;
 }
 . = ALIGN(8); __bug_table : AT(ADDR(__bug_table) - (0xc000000000000000 -0x00000000)) { __start___bug_table = .; KEEP(*(__bug_table)) __stop___bug_table = .; }
 . = ALIGN((1 << 16));
 _edata = .;
 PROVIDE(__unused__edata = .);
 . = ALIGN(0); __bss_start = .; . = ALIGN(0); .sbss : AT(ADDR(.sbss) - (0xc000000000000000 -0x00000000)) { *(.dynsbss) *(.sbss) *(.scommon) } . = ALIGN(0); .bss : AT(ADDR(.bss) - (0xc000000000000000 -0x00000000)) { *(.bss.prominit) . = ALIGN((1 << 16)); *(.bss..page_aligned) . = ALIGN((1 << 16)); *(.dynbss) *(.bss) *(COMMON) } . = ALIGN(0); __bss_stop = .;
 . = ALIGN((1 << 16));
 _end = . ;
 PROVIDE(__unused__end = .);
 .debug 0 : { *(.debug) } .line 0 : { *(.line) } .debug_srcinfo 0 : { *(.debug_srcinfo) } .debug_sfnames 0 : { *(.debug_sfnames) } .debug_aranges 0 : { *(.debug_aranges) } .debug_pubnames 0 : { *(.debug_pubnames) } .debug_info 0 : { *(.debug_info .gnu.linkonce.wi.*) } .debug_abbrev 0 : { *(.debug_abbrev) } .debug_line 0 : { *(.debug_line) } .debug_frame 0 : { *(.debug_frame) } .debug_str 0 : { *(.debug_str) } .debug_loc 0 : { *(.debug_loc) } .debug_macinfo 0 : { *(.debug_macinfo) } .debug_pubtypes 0 : { *(.debug_pubtypes) } .debug_ranges 0 : { *(.debug_ranges) } .debug_weaknames 0 : { *(.debug_weaknames) } .debug_funcnames 0 : { *(.debug_funcnames) } .debug_typenames 0 : { *(.debug_typenames) } .debug_varnames 0 : { *(.debug_varnames) } .debug_gnu_pubnames 0 : { *(.debug_gnu_pubnames) } .debug_gnu_pubtypes 0 : { *(.debug_gnu_pubtypes) } .debug_types 0 : { *(.debug_types) } .debug_addr 0 : { *(.debug_addr) } .debug_line_str 0 : { *(.debug_line_str) } .debug_loclists 0 : { *(.debug_loclists) } .debug_macro 0 : { *(.debug_macro) } .debug_names 0 : { *(.debug_names) } .debug_rnglists 0 : { *(.debug_rnglists) } .debug_str_offsets 0 : { *(.debug_str_offsets) }
 .comment 0 : { *(.comment) } .symtab 0 : { *(.symtab) } .strtab 0 : { *(.strtab) } .shstrtab 0 : { *(.shstrtab) }
 /DISCARD/ : { *(.exitcall.exit) *(.discard) *(.discard.*) *(.modinfo) *(.gnu.version*) }
 /DISCARD/ : {
  *(*.EMB.apuinfo)
  *(.glink .iplt .plt .comment)
  *(.gnu.version*)
  *(.gnu.attributes)
  *(.eh_frame)
 }
}
